#include <boost/graph/compressed_sparse_row_graph.hpp>

struct VertexProperty {
};

struct EdgeProperty {
};

struct GraphProperty {
   int x;
};

using DirectedGraph = boost::compressed_sparse_row_graph<boost::directedS, VertexProperty, EdgeProperty, GraphProperty>;

using BiDirGraph = boost::compressed_sparse_row_graph<boost::bidirectionalS, VertexProperty, EdgeProperty, GraphProperty>;

struct BiDirGraph2: BiDirGraph {
   // Directly access a graph bundle
   graph_bundled& operator[](boost::graph_bundle_t)
   {
      return get_property(*this);
   }

   const graph_bundled& operator[](boost::graph_bundle_t) const
   {
      return get_property(*this);
   }
};

int main()
{
   DirectedGraph dg;
   BiDirGraph2 bg2;
   BiDirGraph bg;

   dg[boost::graph_bundle].x = 1;  // OK
   bg2[boost::graph_bundle].x = 1; // OK
   bg[boost::graph_bundle].x = 1;  // Error!
}
